\ Enumerated Types
\
\ The Following Enumerations have slightly different names to
\ prevent overloading of common Forth names and those used by
\ defined elsewhere in this package.
\
\ Origional Name        New Name
\
\ On                    On-flag
\ Off                   Off-flag
\ And                   And-Comb
\ Or                    Or-Comb
\ Not                   Not-Comb
\ Xor                   Xor-Comb
\ Base                  Basic
\ X                     X-Cmartype
\ Clip_Rectangle        Clip_Rectangle-Clip
\ Track_On              Track_On-echostate
\ Circle                Circle-Cmartype
\ N.B. Freeze remains the same.


\ Enumeration Definition

Variable Enumeration#

: Tally \ a --
  1 Swap +! ;

: -&- \ --
    Enumeration# @ Constant
    Enumeration# Tally ;

: :enum \ --
  Enumeration# OFF
  -&- ;



\ Cactstate
:enum ACTIVE -&- INACTIVE


\ Cacttype
:enum CLEAR -&- NO_OP -&- RETAIN



\ Casptype
:enum INDIVIDUAL -&- BUNDLED


\ Cawresult
:enum VALID_DATA -&- TIMED_OUT -&- DISABLED -&- WRONG_STATE -&- NOT_SUPPORTED


\ Cbmode
:enum TRANSPARENT -&- OPAQUE


\ Cbitmaptype
:enum BITNOT -&- BITTRUE


\ Cintertype
:enum HOLLOW -&- SOLIDI -&- PATTERN -&- HATCH


\ Cprectype
:enum STRING -&- CHARACTER -&- STROKE


\ Clintype
:enum SOLID -&- DOTTED -&- DASHED -&- DASHED_DOTTED 
            -&- DASH_DOT_DOTTED -&- LONG_DASHED


\ Cmartype
:enum DOT -&- PLUS -&- ASTERISK -&- CIRCLE-Cmartype -&- X-Cmartype



\ Ccflag
:enum OPEN -&- CLOSE


\ Cchangetype
:enum YES -&- NO


\ Cclip
:enum NOCLIP -&- CLIP -&- CLIP_RECTANGLE-Clip


\ Cclosetype
:enum CHORD -&- PIE


\ Ccombtype
:enum REPLACE -&- AND-Comb -&- OR-Comb -&- NOT-Comb -&- XOR-Comb



\ Cdevoff
:enum IC_LOCATOR -&- IC_STROKE 
                 -&- IC_VALUATOR -&- IC_CHOICE -&- IC_STRING -&- IC_PICK


\ Cechoav
:enum E_TRACK -&- E_ECHO -&- E_TRACK_OR_ECHO -&- E_TRACK_AND_ECHO


\ Cechostate
:enum ECHO_OFF -&- ECHO_ON -&- TRACK_ON-echostate


\ Cechotype
:enum NO_ECHO -&- PRINTERS_FIST -&- HIGHLIGHT -&- RUBBER_BAND_BOX 
              -&- DOTTED_LINE -&- SOLID_LINE -&- STRING_ECHO 
              -&- XLINE -&- YLINE


\ Cendstyle
:enum NATURAL -&- POINT -&- BEST_FIT


\ Ceqflow
:enum NO_OFLO -&- OFLO


\ Cerrtype
:enum INTERRUPT -&- NO_ACTION -&- POLL


\ Cexttype
:enum CLIP_RECT -&- VIEWPORT -&- VIEWSURFACE


\ Cflag
:enum OFF-flag -&- ON-flag



\ Cfreeze
:enum FREEZE -&- REMOVE



\ Clogical
:enum L_FALSE -&- L_TRUE



\ Clidstate
:enum RELEASE -&- NO_EVENTS -&- REQUEST_EVENT -&- RESPOND_EVENT 
              -&- QUEUE_EVENT



\ Cinputability
:enum NO_INPUT -&- ALWAYS_ON -&- SETTABLE -&- DEPENDS_ON_LID



\ Cpromstate
:enum PROMPT_OFF -&- PROMPT_ON


\ Cackstate
:enum ACK_ON -&- ACK_OFF



\ Cmesstype
:enum SIMULTANEOUS_EVENT_FOLLOWS -&- SINGLE_EVENT


\ Cpathtype
:enum RIGHT -&- LEFT -&- UP -&- DOWN


\ Chaligntype
:enum LFT -&- CNTER -&- RGHT -&- NRMAL -&- CNT


\ Cvaligntype
:enum TOP -&- CAP -&- HALF -&- BASIC -&- BOTTOM -&- NORMAL -&- CONT


\ Cqtype
:enum NOT_VALID -&- EMPTY -&- NON_EMPTY -&- ALMOST_FULL -&- FULL


\ Cspecmode
:enum ABSOLUTE -&- SCALED


\ Csuptype
:enum NONE -&- REQUIRED_FUNCTIONS_ONLY -&- SOME_NON_REQUIRED_FUNCTIONS
           -&- ALL_NON_REQUIRED_FUNCTIONS



\ Ctextfinal
:enum NOT_FINAL -&- FINAL



\ Cvdctype
:enum INTEGER -&- REAL -&- BOTH
