#makes main


#Fidl Compiler
#
# The Fidl Compiler does not depend on any other files.
# It generates the following header files
#     ENUM.H, PROTO.H, EXTPROTO.H, PRIM.H, EXEC.H
# Thus any file which imports one or more of these
# headers is dependant upon the Fidl compiler and
# the Fidl.src file.



pinc:   cweed main.o threads.o prim1.o prim2.o stacks.o\
	    inner.o carve.o dicmanip.o casecon.o\
	    dicload.o headtrav.o n2str.o str2n.o error.o io.o
	cc -o pinc main.o threads.o prim1.o prim2.o stacks.o \
	 inner.o carve.o dicmanip.o casecon.o\
	 dicload.o headtrav.o n2str.o str2n.o error.o io.o

cweed:  cwforth.o threads.o cweed.o cwprim1.o cwprim2.o stacks.o\
	   cwinner.o carve.o dicmanip.o casecon.o\
	   dicload.o headtrav.o n2str.o str2n.o error.o io.o
	cc -o cweed cwforth.o threads.o cweed.o cwprim1.o cwprim2.o stacks.o\
	 cwinner.o carve.o dicmanip.o casecon.o dicload.o \
	 headtrav.o n2str.o str2n.o error.o io.o

cwforth.o:	  main.c extproto.h pinc.h cmodel.h lowram.h vmsize.h
	rm -f c.cwforth
#	delete c.cwforth
	cc -pcc -DCWEED -c  cwforth.c

fidl:   fidl.o
	cc -o fidl fidl.o

fidl.o: fidl.c
	cc -pcc -c fidl.c

casecon.o:	  casecon.c
	cc -pcc -c casecon.c


io.o:   io.c pinc.h cmodel.h vmsize.h lowram.h strsizes.h
	cc -pcc -c io.c


headtrav.o:	  headtrav.c pinc.h cmodel.h vmsize.h nfmasks.h enum.h
	cc -pcc -c headtrav.c


threads.o:	  threads.c pinc.h vocs.h cmodel.h lowram.h misc.h\
	     vmsize.h nfmasks.h
	cc -pcc -c threads.c


prim1.o: prim1.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim1.h proto.h os.h enum.h
	fidl src.fidl
	cc -pcc -c prim1.c

prim2.o: prim2.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim2.h proto.h os.h enum.h
	fidl src.fidl
	cc -pcc -c prim2.c


cwprim1.o:	  cwprim1.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim1.h proto.h os.h
	fidl src.fidl
	delete c.cwprim1
	copy c.prim1 c.cwprim1 ~c
	cc -pcc -DCWEED -c cwprim1.c

cwprim2.o:	  cwprim2.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim2.h proto.h os.h
	fidl src.fidl
	delete c.cwprim2
	copy c.prim2 c.cwprim2 ~c
	cc -pcc -DCWEED -c cwprim2.c


error.o:	  error.c extproto.h pinc.h cmodel.h\
          lowram.h strsizes.h fname.h vmsize.h
	cc -pcc -c error.c


stacks.o:	  stacks.c cmodel.h vmsize.h misc.h
	cc -pcc -c stacks.c


inner.o:	  inner.c pinc.h cmodel.h vmsize.h prim1.h prim2.h misc.h\
		  enum.h
	cc -pcc -c inner.c


cwinner.o:	  inner.c pinc.h cmodel.h vmsize.h prim1.h prim2.h
	delete c.cwinner
	copy c.inner c.cwinner ~c
	cc -pcc -DCWEED -c  cwinner.c


carve.o:	  carve.c cmodel.h dicmanip.c vocs.h lowram.h nfmasks.h vmsize.h\
	   prim1.h prim2.h misc.h
	cc -pcc -c carve.c


dicmanip.o:	  dicmanip.c pinc.h cmodel.h vmsize.h
	cc -pcc -c dicmanip.c


dicload.o:	  dicload.c pinc.h cmodel.h vmsize.h strsizes.h
	cc -pcc -c dicload.c


n2str.o:	  n2str.c cmodel.h vmsize.h lowram.h
	cc -pcc -c n2str.c


str2n.o:	  str2n.c cmodel.h vmsize.h lowram.h
	cc -pcc -c str2n.c


cweed.o:	  cweed.c pinc.h cmodel.h lowram.h nfmasks.h vmsize.h
	cc -pcc -c cweed.c


main.o: main.c extproto.h pinc.h cmodel.h lowram.h vmsize.h fname.h enum.h
	cc -pcc -c main.c







lexicon:	prim1.h prim2.h misc.h cscape
	cweed
