#makes main


#Fidl Compiler
#
# The Fidl Compiler does not depend on any other files.
# It generates the following header files
#     ENUM.H, PROTO.H, EXTPROTO.H, PRIM.H, EXEC.H
# Thus any file which imports one or more of these
# headers is dependant upon the Fidl compiler and
# the Fidl.src file.


fidl.obj: fidl.c
	CL /AL /c fidl.c

fidl.exe:   fidl.obj
	CL /AL /Fefidl.exe fidl.obj;


prim.h: fidl.src xcomp.src fidl.exe
	fidl.exe fidl.src xcomp.src


casecon.obj:	  casecon.c
	CL /AL /c /Ox casecon.c


io.obj:   io.c pinc.h cmodel.h vmsize.h lowram.h strsizes.h
	CL /AL /c /Ox io.c


headtrav.obj:	  headtrav.c pinc.h cmodel.h vmsize.h nfmasks.h enum.h
	CL /AL /c /Ox headtrav.c


threads.obj:	  threads.c pinc.h vocs.h cmodel.h lowram.h misc.h\
	     vmsize.h nfmasks.h
	CL /AL /c /Ox threads.c


xcprim.obj: prim.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim.h proto.h os.h
	CL /AL /DDONGLE /c /Ox /Foxcprim.obj prim.c


cwprim.obj:	  prim.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim.h proto.h os.h
	CL /AL /DCWEED /c /Focwprim.obj prim.c


error.obj:	  error.c extproto.h pinc.h cmodel.h\
          lowram.h strsizes.h fname.h vmsize.h
	CL /AL /c /Ox error.c


stacks.obj:	  stacks.c cmodel.h vmsize.h misc.h
	CL /AL /c /Ox stacks.c


inner.obj:	  inner.c pinc.h cmodel.h vmsize.h prim.h misc.h enum.h
	CL /AL /c /Ox inner.c


cwinner.obj:	  inner.c pinc.h cmodel.h vmsize.h prim.h enum.h
	CL /AL /DCWEED /c /Focwinner.obj inner.c


carve.obj:	  carve.c cmodel.h dicmanip.c vocs.h lowram.h nfmasks.h vmsize.h\
	   prim.h misc.h
	CL /AL /c /Ox carve.c


dicmanip.obj:	  dicmanip.c pinc.h cmodel.h vmsize.h enum.h
	CL /AL /c dicmanip.c


dicload.obj:	  dicload.c pinc.h cmodel.h vmsize.h strsizes.h
	CL /AL /c /Ox dicload.c


n2str.obj:	  n2str.c cmodel.h vmsize.h lowram.h
	CL /AL /c /Ox n2str.c


str2n.obj:	  str2n.c cmodel.h vmsize.h lowram.h
	CL /AL /c /Ox str2n.c


cweed.obj:	  cweed.c pinc.h cmodel.h lowram.h nfmasks.h vmsize.h
	CL /AL /c  cweed.c


xcmain.obj: main.c extproto.h pinc.h cmodel.h lowram.h vmsize.h fname.h enum.h
	CL /AL /DDONGLE /c /Ox /Foxcmain.obj main.c


cwforth.obj:	  main.c extproto.h pinc.h cmodel.h lowram.h vmsize.h
	CL /AL /DCWEED /c /Focwforth.obj main.c


dongle.obj:     dongle\dongle.c
        CL /AL /c /Fodongle.obj dongle\dongle.c


##########################################################################
# LINK is used instead of CL because the argument list is truncated when #
# passed from the compiler to the linker (128 chars only). If there is   #
# a way to avoid this then use CL instead.                               #
##########################################################################

cweed.exe:  cwforth.obj threads.obj cweed.obj cwprim.obj stacks.obj\
           cwinner.obj carve.obj dicmanip.obj casecon.obj\
           dicload.obj headtrav.obj n2str.obj str2n.obj error.obj io.obj
	LINK cwforth threads cweed cwprim stacks\
         cwinner carve dicmanip casecon dicload\
         headtrav n2str str2n error io, cweed.exe;


###############################################
# Uncomment this block for XCPINC generation. #
# Add DONGLE definition to DONGLE.H           #
###############################################

xcpinc.exe:   cweed.exe xcmain.obj threads.obj xcprim.obj stacks.obj\
	     slii.obj dongle.obj inner.obj carve.obj dicmanip.obj casecon.obj\
	    dicload.obj headtrav.obj n2str.obj str2n.obj error.obj io.obj
	LINK xcmain threads xcprim stacks dongle slii\
	 inner carve dicmanip casecon\
	 dicload headtrav n2str str2n error io, xcpinc.exe;


lexicon:       prim.h misc.h cscape enum.h
	cweed
