#line 85 "fidl.src"
void noop( void )
{
}

#line 90 "fidl.src"
void words( void )
{
    unsigned CELL *cell;

    cell = (unsigned CELL *) &ram[ CONTEXT_AREA ];/* 12/07/90 sfp */
    if( *cell ) list_voc( *cell );
}

#line 99 "fidl.src"
void order( void )
{
    int i;
    unsigned CELL *context, *current, *cell;

    fprintf( output.stream, "\nContext: " );
    context = (unsigned CELL *) &ram[ CONTEXT_AREA ];

    for( i=0; i<MAX_VOCS; i++ )
      if( *(context+i) )
           fprintf( output.stream, "%s ",
                 &ram[ cfa_to_nfa( *(context+i)-CELL_SIZE)+1 ] );

    fprintf( output.stream, "\nCurrent: " );
    current = (unsigned CELL *) &ram[ CURRENT_AREA ];
    fprintf( output.stream, "%s\n",
           &ram[ cfa_to_nfa( (*current)-CELL_SIZE )+1 ] );
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = 0;
}

#line 121 "fidl.src"
void also( void )
{
    unsigned CELL *context;
    int i;

    context = (unsigned CELL *) &ram[ CONTEXT_AREA ];
    for( i = (MAX_VOCS - 1); i>0; i-- ) {
      *(context+i) = *(context+i-1);
    }
}

#line 132 "fidl.src"
void definitions( void )
{
    unsigned CELL *first_of_context, *current;

    first_of_context = (unsigned CELL *) &ram[ CONTEXT_AREA ];
    current = (unsigned CELL *) &ram[ CURRENT_AREA ];
    *current = *first_of_context;
}

#line 141 "fidl.src"
void only( void )
{
    unsigned CELL *context, *root_voc;
    unsigned CELL *first_of_context, *current;
    int i;

    context = (unsigned CELL *) &ram[ CONTEXT_AREA ];
    for( i = 0; i < MAX_VOCS; i++ ) {
        *(context+i) = (CELL) 0;
    }
    root_voc = (unsigned CELL *) &ram[ ROOT_VOC ];
    first_of_context = (unsigned CELL *) &ram[ CONTEXT_AREA ];
    *first_of_context = *root_voc;
    current = (unsigned CELL *) &ram[ CURRENT_AREA ];
    *current = *first_of_context;
    also();
}

#line 159 "fidl.src"
void previous( void )
{
      unsigned CELL *context;
      int i;

      context = (unsigned CELL *) &ram[ CONTEXT_AREA ];
      for( i = 0; i<(MAX_VOCS-1); i++) {
           *(context+i) = *(context+i+1);
      }
      *(context+(MAX_VOCS-1)) = 0;
}

#line 171 "fidl.src"
void vocabulary( void )
{
    char word[ WORD_LENGTH ];
    unsigned CELL *cell;

    if( get_word( word ))
    {
      if( defined_in_this_voc( word,
                       *((unsigned CELL *) &ram[ CURRENT_AREA ] )))
      {
          fprintf( stderr, "%s is redefined\n", word );
          cell = (unsigned CELL *) &ram[ OUT ];
          (*cell) = 0;
      }
      carve_voc( word );
    }
    else
        do_error( (CELL) 145 );
}

#line 191 "fidl.src"
void dump( void )
{
    unsigned CELL from, to, start, *cell;

    fprintf( output.stream, "\n" );
    to = pop_data();
    from = pop_data();
    for( start=from; start<from+to; start+=12 )
    {
      unsigned CELL j;

      fprintf( output.stream, "%4x  ", start );
      for( j=start; j<start+12; j++ )
          if( (int) ram[j] < 16 )
           fprintf( output.stream, "  0%1x", ram[j] );
          else
           fprintf( output.stream, "  %2x", ram[j] );
      fprintf( output.stream, "    " );
      for( j=start; j<start+12; j++ )
          if( ram[j] > 31 )
           fprintf( output.stream, "%c", ram[j] );
          else
           fprintf( output.stream, "." );
      fprintf( output.stream, "\n" );
    }
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = 0;
}

#line 220 "fidl.src"
void paren_bye( void )
{
    longjmp( environment, 0 );
}

#line 225 "fidl.src"
void bye( void )
{
    fprintf( output.stream, "\n\nGoodbye\n" );
    paren_bye();
}

#line 234 "fidl.src"
void drop( void )
{
    sp--;
}

#line 239 "fidl.src"
void two_drop( void )
{
    sp -= 2;
}

#line 244 "fidl.src"
void pf_dup( void )
{
    sp += 1;
    data_stack[ sp ] = data_stack[ sp-1 ];
}

#line 250 "fidl.src"
void nip( void )
{
    data_stack[ sp-1 ] = data_stack[ sp ];
    sp -= 1 ;
}

#line 256 "fidl.src"
void two_dup( void )
{
    sp += 2;
    data_stack[ sp-1 ] = data_stack[ sp-3 ];
    data_stack[ sp ] = data_stack[ sp-2 ];
}

#line 263 "fidl.src"
void swap( void )
{
    unsigned CELL temp;

    temp = data_stack[ sp ];
    data_stack[ sp ] = data_stack[ sp-1 ];
    data_stack[ sp-1 ] = temp;
}

#line 275 "fidl.src"
void two_swap( void )
{
      unsigned CELL data1, data2, data3, data4;

      data1 = data_stack[ sp-- ];
      data2 = data_stack[ sp-- ];
      data3 = data_stack[ sp-- ];
      data4 = data_stack[ sp ];
      data_stack[ sp ] = data2;
      data_stack[ ++sp ] = data1;
      data_stack[ ++sp ] = data4;
      data_stack[ ++sp ]   = data3;
}

#line 289 "fidl.src"
void over( void )
{
    sp += 1;
    data_stack[ sp ] = data_stack[ sp-2 ];
}

#line 295 "fidl.src"
void two_over( void )
{
      unsigned CELL temp1, temp2;
      temp1 = data_stack[ sp-2 ];
      temp2 = data_stack[ sp-3 ];
      data_stack[ ++sp ] = temp2;
      data_stack[ ++sp ] = temp1;
}

#line 304 "fidl.src"
void rot( void )
{
    unsigned CELL temp;

    temp = data_stack[ sp-2 ];
    data_stack[ sp-2 ] = data_stack[ sp-1 ];
    data_stack[ sp-1 ] = data_stack[ sp ];
    data_stack[ sp ] = temp;
}

#line 314 "fidl.src"
void minus_rot( void )
{
    unsigned CELL temp;

    temp = data_stack[ sp ];
    data_stack[ sp ] = data_stack[ sp-1 ];
    data_stack[ sp-1 ] = data_stack[ sp-2 ];
    data_stack[ sp-2 ] = temp;
}

#line 324 "fidl.src"
void tuck( void )
{
    sp += 1;
    data_stack[ sp ]   = data_stack[ sp-1 ];
    data_stack[ sp-1 ] = data_stack[ sp-2 ];
    data_stack[ sp-2 ] = data_stack[ sp ];
}

#line 332 "fidl.src"
void query_dup( void )
{
    unsigned CELL data;

    if ((data = data_stack[ sp ]) != 0)
       data_stack[ ++sp ] = data;
}

#line 340 "fidl.src"
void pick( void )
{
      unsigned CELL item_number;

      item_number = data_stack[ sp ];
      data_stack[ sp ] = data_stack[ sp - item_number - 1 ];
}

#line 348 "fidl.src"
void roll( void )
{
    unsigned CELL item_number, i, data;

    item_number = data_stack[ sp-- ];
    data = data_stack[ sp-item_number ];

    for( i = item_number; i > 0; i-- )
        data_stack[ sp-i ] = data_stack[ sp-i+1 ];
    data_stack[ sp ] = data;
}

#line 360 "fidl.src"
void sp_fetch( void )
{

      unsigned CELL temp;

      temp = sp;
      data_stack[ ++sp ] = temp;
}

#line 369 "fidl.src"
void sp_store( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp ];
      sp = temp;
}

#line 377 "fidl.src"
void s0( void )
{
      data_stack[ ++sp ] = (unsigned CELL) (S0);
}

#line 382 "fidl.src"
void rp_fetch( void )
{
      data_stack[ ++sp ] = rp;
}

#line 387 "fidl.src"
void rp_store( void )
{
      rp = data_stack[ sp-- ];
}

#line 392 "fidl.src"
void r0( void )
{
      data_stack[ ++sp ] = (unsigned CELL) (R0);
}

#line 397 "fidl.src"
void to_r( void )
{
    return_stack[ ++rp ] = data_stack[ sp-- ];
}

#line 402 "fidl.src"
void r_from( void )
{
    data_stack[ ++sp ] = return_stack[ rp-- ];
}

#line 407 "fidl.src"
void r_fetch( void )
{
    data_stack[ ++sp ] = return_stack[ rp ];
}

#line 412 "fidl.src"
void one_plus( void )
{
     data_stack[ sp ] += 1;/* 12/07/90 sfp */
}

#line 418 "fidl.src"
void two_plus( void )
{
    data_stack[ sp ] += 2;/* 12/07/90 sfp */
}

#line 423 "fidl.src"
void one_minus( void )
{
    data_stack[ sp ] -= 1;/* 12/07/90 sfp */
}

#line 429 "fidl.src"
void two_minus( void )
{
    data_stack[ sp ] -= 2;/* 12/07/90 sfp */
}

#line 434 "fidl.src"
void plus_store( void )
{
    unsigned CELL * cell;

    cell = (unsigned CELL *) &ram[ data_stack[ sp ] ];
    *cell = *cell + data_stack [ sp-1 ];
    sp -= 2;
}

#line 443 "fidl.src"
void c_plus_store( void )
{
    unsigned CELL address;

    address = pop_data();
    ram[ address ] = ram[ address ] + (unsigned char) pop_data();
}

#line 451 "fidl.src"
void c_fetch( void )
{
    data_stack[ sp ] = (unsigned CELL) ram[ data_stack[ sp ] ];
}

#line 456 "fidl.src"
void c_store( void )
{
    unsigned CELL address;

    address = data_stack[ sp-- ];
    ram[ address ] = (char) data_stack[ sp-- ];
}

#line 465 "fidl.src"
void fetch( void )
{
    data_stack[ sp ] = *((unsigned CELL *) &ram[ data_stack[ sp ] ]);
}

#line 470 "fidl.src"
void store( void )
{
    unsigned CELL *cell;

    cell = (unsigned CELL *) &ram[ data_stack[ sp-- ] ];
    *cell = data_stack[ sp-- ];
}

#line 483 "fidl.src"
void two_fetch( void )
{
      unsigned CELL address;

      address = data_stack[ sp ];
      data_stack[ sp ] = *((unsigned CELL *) &ram[ address + CELL_SIZE ]);
      data_stack[ ++sp ] = *((unsigned CELL *) &ram[ address ]);
}

#line 493 "fidl.src"
void two_store( void )
{
      unsigned CELL address;
      unsigned CELL * cell;

      address = data_stack[ sp-- ];
      cell = (unsigned CELL *) &ram[ address ];
      *cell = data_stack[ sp-- ];
      cell = (unsigned CELL *) &ram [ address + CELL_SIZE ];
      *cell = data_stack[ sp-- ];
}

#line 506 "fidl.src"
void plus( void )
{
    data_stack[ sp-1 ] += data_stack[ sp ];
    sp -= 1;
}

#line 512 "fidl.src"
void minus( void )
{
    data_stack[ sp-1 ] -= data_stack[ sp ];
    sp -= 1;
}

#line 519 "fidl.src"
void two_star( void )
{
    data_stack[ sp ] *= (CELL) 2;
}

#line 524 "fidl.src"
void two_slash( void )
{
/* note that this is a signed one bit right shift */
    data_stack[ sp ] =(CELL)data_stack[ sp ] >> 1;
}

#line 531 "fidl.src"
void star( void )
{
    CELL temp;                        /* 12/07/90 sfp */

    temp = ((CELL) data_stack[ sp ]) * ((CELL) data_stack[ sp-1 ]);
    sp -= 1;
    data_stack[ sp ] = temp;   /* *= did not work on all compilers */
}

#line 540 "fidl.src"
void slash( void )
{
// ATH TODO needs optimising
//   data_stack[ sp-1 ] /= (CELL) data_stack[ sp ];  /* 12/07/90 sfp */
    CELL a,b;				/* SFP100 */

    b=pop_data();
    a=pop_data();

    push_data(a/b);
//    sp -= 1;
}

#line 554 "fidl.src"
void u_star( void )
{
      unsigned CELL temp1, temp2;

      temp1 = data_stack[ sp-- ];
      temp2 = data_stack[ sp ];
      data_stack[ sp ] = temp1 * temp2 ;
}

#line 563 "fidl.src"
void u_slash( void )
{
      unsigned CELL divisor, dividend;

      divisor = data_stack[ sp-- ];
      dividend = data_stack[ sp ];
      data_stack[ sp ] = dividend / divisor ;
}

#line 591 "fidl.src"
void mod( void )
{
      signed CELL dividend, divisor;

      divisor = (CELL) data_stack[ sp-- ];
      dividend = (CELL) data_stack[ sp ];
      data_stack[ sp ] = (unsigned CELL) (dividend % divisor);
}

#line 600 "fidl.src"
void u_mod( void )
{
      unsigned CELL dividend, divisor;

      divisor = data_stack[ sp-- ];
      dividend = data_stack[ sp ];
      data_stack[ sp ] = dividend % divisor;
}

#line 609 "fidl.src"
void slash_mod( void )
{
      signed CELL dividend, divisor;

      divisor = data_stack[ sp ];
      dividend = data_stack[ sp-1 ];
      data_stack[ sp-1 ] = (unsigned CELL) (dividend % divisor);
      data_stack[ sp ] = (unsigned CELL) (dividend / divisor);
}

#line 619 "fidl.src"
void u_slash_mod( void )
{
      unsigned CELL dividend, divisor;

      divisor = data_stack[ sp ];
      dividend = data_stack[ sp-1 ];
      data_stack[ sp-1 ] = dividend % divisor;
      data_stack[ sp ] = dividend / divisor;
}

#line 630 "fidl.src"
void negate( void )
{
      CELL temp;

      temp = data_stack[ sp ];
      temp = -temp;
      data_stack[ sp ] = temp;
}

#line 639 "fidl.src"
void query_negate( void )
{
    signed CELL sign;

    sign = (signed CELL) data_stack[ sp-- ];
    if ( sign<0 )
       data_stack[ sp ] = - (signed CELL) data_stack[ sp ];
}

#line 648 "fidl.src"
void absolute_value( void )
{
      signed CELL data;

      data = (signed CELL) data_stack[ sp ];
      if  (data<0)
          data_stack[ sp ] = -data;
}

#line 657 "fidl.src"
void or( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp-- ];
      data_stack[ sp ] = data_stack[ sp ] | temp;
}

#line 665 "fidl.src"
void and( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp-- ];
      data_stack[ sp ] = data_stack[ sp ] & temp;
}

#line 673 "fidl.src"
void xor( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp-- ];
      data_stack[ sp ] = data_stack[ sp ] ^ temp;
}

#line 682 "fidl.src"
void not( void )
{
      data_stack[ sp ] = ~data_stack[ sp ];
}

#line 689 "fidl.src"
void left_shift( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp-- ];
      data_stack[ sp ] = data_stack[ sp ] << temp;
}

#line 697 "fidl.src"
void right_shift( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp-- ];
      data_stack[ sp ] = data_stack[ sp ] >> temp;
}

#line 705 "fidl.src"
void lshift( void )
{
  unsigned CELL item, count;

  count = data_stack[ sp-- ];
  item = data_stack[ sp ];
  item = item << count;
  data_stack[ sp ] = item;
}

#line 715 "fidl.src"
void rshift( void )
{
  unsigned CELL item, count;

  count = data_stack[ sp-- ];
  item = data_stack[ sp ];
  item = item >> count;
  data_stack[ sp ] = item;
}

#line 725 "fidl.src"
void arshift( void )
{
  CELL item;
  unsigned CELL count;

  count = data_stack[ sp-- ];
  item = data_stack[ sp ];
  item = item >> count;
  data_stack[ sp ] = item;
}

#line 736 "fidl.src"
void maximum_value( void )
{
      signed CELL data1, data2;

      data1 = (signed CELL) data_stack[ sp-- ];
      data2 = (signed CELL) data_stack[ sp ];
      if (data1>data2)
         data_stack[ sp ] = data1;
}

#line 746 "fidl.src"
void minimum_value( void )
{
      signed CELL data1, data2;

      data1 = (signed CELL) data_stack[ sp-- ];
      data2 = (signed CELL) data_stack[ sp ];
      if (data1<data2)
         data_stack[ sp ] = data1;
}

#line 757 "fidl.src"
void zero_less_than( void )
{
      if ((signed CELL) data_stack[ sp ] < 0)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 765 "fidl.src"
void zero_greater_than( void )
{
      if ((signed CELL) data_stack[ sp ] > 0)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 773 "fidl.src"
void zero_equals( void )
{
      if (data_stack[ sp ] == 0)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 781 "fidl.src"
void zero_not_equals( void )
{
      if (data_stack[ sp ] != 0)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 792 "fidl.src"
void equals( void )
{
      unsigned CELL data;

      data = data_stack[ sp-- ];
      if (data_stack[ sp ] == data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 807 "fidl.src"
void not_equals( void )
{
      unsigned CELL data;

      data = data_stack[ sp-- ];
      if (data_stack[ sp ] != data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 821 "fidl.src"
void less_than( void )
{
      signed CELL data;

      data = (signed CELL) data_stack[ sp-- ];
      if ((signed CELL) data_stack[ sp ] < data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 835 "fidl.src"
void greater_than( void )
{
      signed CELL data;

      data = (signed CELL) data_stack[ sp-- ];
      if ((signed CELL) data_stack[ sp ] > data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 849 "fidl.src"
void less_than_or_equal( void )
{
      signed CELL data;

      data = (signed CELL) data_stack[ sp-- ];
      if ((signed CELL) data_stack[ sp ] <= data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 863 "fidl.src"
void greater_than_or_equal( void )
{
      signed CELL data;

      data = (signed CELL) data_stack[ sp-- ];
      if ((signed CELL) data_stack[ sp ] >= data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 877 "fidl.src"
void unsigned_less_than( void )
{
      unsigned CELL data;

      data = data_stack[ sp-- ];
      if (data_stack[ sp ] < data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 891 "fidl.src"
void unsigned_greater_than( void )
{
      unsigned CELL data;

      data = data_stack[ sp-- ];
      if (data_stack[ sp ] > data)
         data_stack[ sp ] = TRUE;
      else
         data_stack[ sp ] = FALSE;
}

#line 905 "fidl.src"
void within_query( void )
{
      signed CELL data1, data2, data3;

      data3 = (signed CELL) data_stack[ sp-- ];
      data2 = (signed CELL) data_stack[ sp-- ];
      data1 = (signed CELL) data_stack[ sp ];
      data_stack[ sp ] = ((unsigned CELL)
                    ((data2 <= data1) && (data1 <= data3))
                    ? (unsigned CELL) TRUE
                    : (unsigned CELL) FALSE);
}

#line 921 "fidl.src"
void set_bit( void )
{
      unsigned CELL address;
      unsigned char mask;

      address = data_stack[ sp-- ];
      mask = (unsigned char) data_stack[ sp-- ];
      ram[ address ] |= mask;
}

#line 934 "fidl.src"
void reset_bit( void )
{
      unsigned CELL address;
      unsigned char mask;

      address = data_stack[ sp-- ];
      mask = (unsigned char) data_stack[ sp-- ];
      ram[ address ] &= ~mask;
}

#line 948 "fidl.src"
void toggle_bit( void )
{
      unsigned CELL address;
      unsigned char mask;

      address = data_stack[ sp-- ];
      mask = (unsigned char) data_stack[ sp-- ];
      ram[ address ] ^= mask;
}

#line 961 "fidl.src"
void test_bit( void )
{
      unsigned CELL address;
      unsigned char mask;

      address = data_stack[ sp-- ];
      mask = (unsigned char) data_stack[ sp ];
      data_stack[ sp ] = ram[ address ] & mask;
}

#line 971 "fidl.src"
void paren_emit( void )
{

    unsigned char ch;
    unsigned CELL * cell;

    ch = (unsigned char) data_stack[ sp-- ];
    putc( ch, output.stream );
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell)++;
}

#line 983 "fidl.src"
void paren_key( void )
{
    unsigned char ch;

#if IMPLEMENTATION == SUN || IMPLEMENTATION == Linux
    set_raw_io();
    ch = getc( input.stream );
    set_cooked_io();
#else
#if IMPLEMENTATION == OS9
    ch = getc( input.stream );
#else
#if IMPLEMENTATION == MicrosoftC
    ch = getch();
#else
#if IMPLEMENTATION == RISCOS
    ch = getc( input.stream );
#else
#if IMPLEMENTATION == TurboC
    ch = getch();
#else
#if IMPLEMENTATION == MinGW64
    ch = getch();
#else
    #error No Implementation Specified
#endif
#endif
#endif
#endif
#endif
#endif

    data_stack[ ++sp ] = (unsigned CELL) ch;
}

#line 1018 "fidl.src"
void paren_key_query( void )
{
#if IMPLEMENTATION == SUN || IMPLEMENTATION == Linux
   set_raw_io();
   push_data( (CELL) (-1*key_pressed()));
   set_cooked_io();
#else
#if IMPLEMENTATION == MicrosoftC
    (signed CELL) data_stack [ ++sp ] = (signed CELL) (-1*kbhit());
#else
#if IMPLEMENTATION == TurboC
    (signed CELL) data_stack [ ++sp ] = (signed CELL) (-1*kbhit());
#else
#if IMPLEMENTATION == Linux || IMPLEMENTATION == Linux64
    data_stack[ ++sp ] = (unsigned CELL) TRUE;
#else
#if IMPLEMENTATION == OS9
    data_stack[ ++sp ] = (unsigned CELL) TRUE;
#else
#if IMPLEMENTATION == MinGW64
    data_stack[ ++sp ] = (unsigned CELL) _kbhit();
#else
    #error No Implementation Specified
#endif
#endif
#endif
#endif
#endif
#endif
}

#line 1049 "fidl.src"
void raw( void )
{
#if IMPLEMENTATION == SUN
    set_raw_io();
#endif
}

#line 1056 "fidl.src"
void cooked( void )
{
#if IMPLEMENTATION == SUN
    set_cooked_io();
#endif
}

#line 1063 "fidl.src"
void lit( void )
{
    data_stack[ ++sp ] = *((unsigned CELL *) &ram[ ip ]);
    ip += CELL_SIZE;
}

#line 1070 "fidl.src"
void dot( void )
{
    unsigned CELL *cell;
    char number_string[ 34 ];

    number_to_string( data_stack[ sp-- ], number_string );
    fprintf( output.stream, "%s ", number_string );
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = (*cell) + (unsigned CELL) strlen( number_string ) + 1;
			/* allow for extra space */
}

#line 1082 "fidl.src"
void udot( void )
{
    unsigned CELL *cell;
    char number_string[ 34 ];

    unsigned_number_to_string( data_stack[ sp-- ], number_string );
    fprintf( output.stream, "%s ", number_string );
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = (*cell) + (unsigned CELL) strlen( number_string ) + 1;
			/* allow for extra space */
}

#line 1094 "fidl.src"
void dot_r( void )
{
    char number_string[ 34 ];
    unsigned CELL field_width;

    field_width = data_stack[ sp-- ];
    number_to_string( data_stack[ sp-- ], number_string );
    print_string_in_field( number_string, field_width, ' ' );
}

#line 1104 "fidl.src"
void udot_r( void )
{
    char number_string[ 34 ];
    unsigned CELL field_width;

    field_width = data_stack[ sp-- ];
    unsigned_number_to_string( pop_data(), number_string );
    print_string_in_field( number_string, field_width, ' ' );
}

#line 1114 "fidl.src"
void dots( void )
{
    int i;
    char in_decimal[ 12 ], in_hex[ 10 ], in_binary[ 34 ];
    unsigned CELL current_base, *cell;

    if( sp == -1 )
      fprintf( output.stream, "\nEmpty Stack\n" );
    else {
      fprintf( output.stream, "\nTop\n" );
        cell = (unsigned CELL *) &ram[ BASE ];
        current_base = *cell;

        for( i=sp; i>-1; i-- ) {
            convert_to_standard_bases( data_stack[i],
                                       in_decimal, in_hex, in_binary );
            print_one_stack_line( current_base, in_decimal, in_hex, in_binary );
        }
        *cell = current_base;
    }
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = 0;
}

#line 1138 "fidl.src"
void latest_fetch( void )
{
      data_stack[ ++sp ] = latest;
}

#line 1143 "fidl.src"
void last_fetch( void )
{
      data_stack[ ++sp ] = latest;
}

#line 1148 "fidl.src"
void last_store( void )
{
      latest = data_stack[ sp-- ];
}

#line 1153 "fidl.src"
void here( void )
{
      data_stack[ ++sp ] = dp;
}

#line 1158 "fidl.src"
void dp_store( void )
{
      dp = data_stack[ sp-- ];
}

#line 1164 "fidl.src"
void colon( void )
{
    char word[ WORD_LENGTH ];

    if( compiling ) do_error( (CELL) 18 );
    else {
        compiling = !compiling;
        store_csp();
      if( get_word( word )) {
          if( defined_in_this_voc( word,
                           *((unsigned CELL *) &ram[ CURRENT_AREA ])))
           fprintf( stderr, "%s is redefined\n", word );
            carve_header( word );
          smudge_latest_word();
          comma_word( dp+CELL_SIZE );
      }
      else
            do_error( (CELL) 145 );
    }
}

#line 1185 "fidl.src"
void semicolon( void )
{
    if( !compiling ) do_error( (CELL) 17 );
    else {
      compiling = !compiling;
        comma_word( (CELL) prim_next );
        query_csp();
        smudge_latest_word();
    }
}

#line 1196 "fidl.src"
void next( void )
{
#ifdef CWEED
    if( !(kill_switch = ((CELL) rp == -1)))
      ip = pop_return();
#else
    ip = return_stack[ rp-- ];
#endif
}

#line 1207 "fidl.src"
void branch( void )
{
      ip = *((unsigned CELL *) &ram[ ip ]);
}

#line 1212 "fidl.src"
void query_branch( void )
{
      ip = ( data_stack[ sp-- ] ?
             ip+CELL_SIZE : *((unsigned CELL *) &ram[ ip ]));
}

#line 1225 "fidl.src"
void paren_of( void )
{
      unsigned CELL temp;

      temp = data_stack[ sp-- ];
      if (temp == data_stack[ sp ])
      {  sp--;
         ip += CELL_SIZE;
      }
      else
         ip = *((unsigned CELL *) &ram[ ip ]);
}

#line 1238 "fidl.src"
void paren_query_of( void )
{
      if (data_stack[ sp-- ] != 0)
         ip += CELL_SIZE;
      else
         ip = *((unsigned CELL *) &ram[ ip ]);
}

#line 1246 "fidl.src"
void paren_endof( void )
{
      ip = *((unsigned CELL *) &ram[ ip ]);
}

#line 1251 "fidl.src"
void paren_case( void )
{
}

#line 1256 "fidl.src"
void paren_semi_code( void )
{
    unsigned CELL cfa, *cell;

    cfa = nfa_to_cfa( latest );
    cell = (unsigned CELL *) &ram[ cfa+CELL_SIZE ];
    *cell = ip;
    next();
}

#line 1267 "fidl.src"
void does_greater_than( void )
{
    comma_word( (unsigned CELL) prim_paren_semi_code );
    comma_word( (unsigned CELL) prim_r_from );
}

#line 1274 "fidl.src"
void do_voc( void )
{
    unsigned CELL *first_of_context, my_cfa;

    my_cfa = ip - CELL_SIZE;
    first_of_context = (unsigned CELL *) &ram[ CONTEXT_AREA ];
    *first_of_context = my_cfa;
#ifdef CWEED
    if( !(kill_switch = ((CELL) rp == -1)))
      ip = pop_return();
#else
    ip = return_stack[ rp-- ];
#endif
}

#line 1289 "fidl.src"
void do_con( void )
{
      data_stack[ ++sp ] = *((unsigned CELL *) &ram[ ip ]);
#ifdef CWEED
      if( !(kill_switch = ((CELL) rp == -1)));
          ip = pop_return();
#else
      ip = return_stack[ rp-- ];
#endif
}

#line 1301 "fidl.src"
void forward_mark( void )
{
    push_data( dp );
    comma_word( (CELL) 0 );
}

#line 1307 "fidl.src"
void forward_resolve( void )
{
    push_data( dp );
    swap();
    store();
}

#line 1314 "fidl.src"
void backward_mark( void )
{
    push_data( dp );
}

#line 1320 "fidl.src"
void backward_resolve( void )
{
    comma_word( pop_data());
}

#line 1326 "fidl.src"
void if_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      comma_word( (CELL) prim_query_branch );
      forward_mark();
      data_stack[ ++sp ] = (signed CELL) IF_STATEMENT;
    }
}

#line 1337 "fidl.src"
void endif_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) IF_STATEMENT )
            do_error( (CELL) 149 );
      else forward_resolve();
    }
}

#line 1348 "fidl.src"
void then_stat( void )
{
    if( !compiling )
      do_error( (CELL) 17);
    else {
      if( pop_data() != (CELL) IF_STATEMENT )
            do_error( (CELL) 149 );
      else forward_resolve();
    }
}

#line 1359 "fidl.src"
void else_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) IF_STATEMENT )
            do_error( (CELL) 150 );
      else {
          push_data( dp + (2*CELL_SIZE) );
          swap();
          store();

          comma_word( (CELL) prim_branch );
          forward_mark();
          push_data( (CELL) IF_STATEMENT);
      }
    }
}

#line 1378 "fidl.src"
void begin_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      backward_mark();
      push_data( (CELL) BEGIN_STATEMENT );
    }
}

#line 1388 "fidl.src"
void while_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) BEGIN_STATEMENT )
            do_error( (CELL) 151 );
      else {
          comma_word( (CELL) prim_query_branch );
          forward_mark();
          push_data( (CELL) WHILE_STATEMENT);
      }
    }
}

#line 1403 "fidl.src"
void repeat_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) WHILE_STATEMENT )
            do_error( (CELL) 152 );
      else {
          comma_word( (CELL) prim_branch );
          push_data( dp + CELL_SIZE );
          swap();
          store();

          backward_resolve();
      }
    }
}

#line 1421 "fidl.src"
void until_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) BEGIN_STATEMENT )
            do_error( (CELL) 153 );
      else {
          comma_word( (CELL) prim_query_branch );
          backward_resolve();
      }
    }
}

#line 1435 "fidl.src"
void again_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) BEGIN_STATEMENT )
            do_error( (CELL) 154 );
      else {
          comma_word( (CELL) prim_branch );
          backward_resolve();
      }
    }
}

#line 1449 "fidl.src"
void string_create( void )
{
    unsigned CELL word_name;

    word_name = pop_data()+1;

    if( defined_in_this_voc( &ram[ word_name ],
                      *((unsigned CELL *) &ram[ CURRENT_AREA ] )))
      fprintf( stderr, "%s is redefined\n", word );
    carve_header( &ram[ word_name ] );
    comma_word( dp+CELL_SIZE );
    comma_word( (unsigned CELL) prim_do_create );
}

#line 1463 "fidl.src"
void create_header( void )
{
    char word[ WORD_LENGTH ];

    if( get_word( word )) {
      if( defined_in_this_voc( word,
                       *((unsigned CELL *) &ram[ CURRENT_AREA ] )))
          fprintf( stderr, "%s is redefined\n", word );
      carve_header( word );
      comma_word( dp+CELL_SIZE );
      comma_word( (unsigned CELL) prim_do_create );
    }
    else
        do_error( (CELL) 145 );
}

#line 1479 "fidl.src"
void do_create( void )
{
    data_stack[ ++sp ] = ip;
#ifdef CWEED
    if( !(kill_switch = ((CELL) rp == -1)))
      ip = pop_return();
#else
    ip = return_stack[ rp-- ];
#endif
}

#line 1490 "fidl.src"
void allot( void )
{
      dp += data_stack[ sp-- ];
}

#line 1495 "fidl.src"
void comma( void )
{
      comma_word( data_stack[ sp-- ] );
}

#line 1500 "fidl.src"
void c_comma( void )
{
      comma_byte( (unsigned char) data_stack[ sp-- ] );
}

#line 1505 "fidl.src"
void paren_do( void )
{
      return_stack[ ++rp ] = *( (unsigned CELL *) &ram [ ip ] );
      return_stack[ ++rp ] = data_stack[ sp-- ];
      return_stack[ ++rp ] = data_stack[ sp-- ];
      ip += CELL_SIZE;
}

#line 1513 "fidl.src"
void paren_query_do( void )
{
      unsigned CELL start, end;

      start = data_stack[ sp-- ];
      end = data_stack[ sp-- ];
      if (start != end)
      {
         return_stack[ ++rp ] = *( (unsigned CELL *) &ram [ ip ] );
         return_stack[ ++rp ] = start;
         return_stack[ ++rp ] = end;
         ip += CELL_SIZE;
      }
      else
         ip = *((unsigned CELL *) &ram[ ip ]);
}

#line 1530 "fidl.src"
void paren_leave( void )
{
      rp -= 2;
      ip = return_stack[ rp-- ];
}

#line 1536 "fidl.src"
void paren_query_leave( void )
{
      if( data_stack[ sp-- ])
      {
         rp -= 2;
         ip = return_stack[ rp-- ];
      }
}

#line 1545 "fidl.src"
void query_do_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      comma_word( (CELL) prim_paren_query_do );
      forward_mark();
      backward_mark();
      push_data( (CELL) DO_STATEMENT );
    }
}

#line 1557 "fidl.src"
void do_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      comma_word( (CELL) prim_paren_do );
      forward_mark();
      backward_mark();
      push_data( (CELL) DO_STATEMENT );
    }
}

#line 1569 "fidl.src"
void leave_stat( void )
{
    unsigned CELL compiler_flag;

    if( !compiling )
        do_error( (CELL) 17 );
    else {
      comma_word( (CELL) prim_paren_leave );
    }
}

#line 1580 "fidl.src"
void query_leave_stat( void )
{
    unsigned CELL compiler_flag;

    if( !compiling )
        do_error( (CELL) 17 );
    else {
      comma_word( (CELL) prim_paren_query_leave );
    }
}

#line 1591 "fidl.src"
void loop_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) DO_STATEMENT )
            do_error( (CELL) 146 );
      else {
          comma_word( (CELL) prim_paren_loop );
          backward_resolve();
          forward_resolve();
      }
    }
}

#line 1606 "fidl.src"
void plus_loop_stat( void )
{
    if( !compiling )
        do_error( (CELL) 17 );
    else {
      if( pop_data() != (CELL) DO_STATEMENT )
            do_error( (CELL) 146 );
      else {
          comma_word( (CELL) prim_paren_plus_loop );
          backward_resolve();
          forward_resolve();
      }
    }
}

#line 1621 "fidl.src"
void paren_loop( void )
{
      unsigned CELL i;

      i = return_stack[ rp-1 ] + 1;
      if (i==return_stack[ rp ])
      {
        rp -= 3;
        ip += CELL_SIZE;
      }
      else
      {
        return_stack[ rp-1 ] = i;
        ip = *((unsigned CELL *) &ram[ ip ]);
      }
}

#line 1638 "fidl.src"
void paren_plus_loop( void )
{
      unsigned CELL i;
      CELL temp;

      temp = data_stack[ sp-- ];
      i = return_stack[ rp-1 ] + temp;
      if ( ((temp>=0) && (i==return_stack[ rp ])) ||
           ((temp<0) && (return_stack[ rp-1 ]==return_stack[ rp ])) )
      {
        rp -= 3;
        ip += CELL_SIZE;
      }
      else
      {
        return_stack[ rp-1 ] = i;
        ip = *((unsigned CELL *) &ram[ ip ]);
      }
}

#line 1658 "fidl.src"
void index_variable_i( void )
{
      data_stack[ ++sp ] = return_stack[ rp-1 ];
}

#line 1663 "fidl.src"
void index_variable_j( void )
{
      data_stack[ ++sp ] = return_stack[ rp-4 ];
}

#line 1669 "fidl.src"
void string_from( void )
{
    unsigned CELL filename;
    FILE *from_file;

#ifdef DONGLE
    test_dongle();
#endif

    filename = pop_data() + 1;
    if(( from_file = fopen( &ram[ filename ], "r" )) == NULL ) {
       trash_rest_of_line();
       init_from_stack();
       do_error( (CELL) 159 );
    }
    else {
#if IMPLEMENTATION == OS9
          fprintf( output.stream, "\nLoading from file %s...", &ram[ filename ] );
          push_from_fileblock( input );
          input = make_from_fileblock( filename, from_file );
          input.last_page_required = pop_data();
          goto_page( pop_data() );
#else
      if( setvbuf( from_file, NULL, _IOFBF, 10240 )) {
          trash_rest_of_line();
          init_from_stack();
          do_error( (CELL) 160 );
       }
      else {
          fprintf( output.stream, "\nLoading from file %s...", &ram[ filename ] );
          push_from_fileblock( input );
          input = make_from_fileblock( &ram[ filename ], from_file );
          input.last_page_required = pop_data();
          goto_page( pop_data() );
      }
#endif
    }
}

#line 1708 "fidl.src"
void from_a_file( void )
{
    char filename[ FROM_FILENAME_LENGTH ];
    FILE *from_file;

#ifdef DONGLE
    test_dongle();
#endif

    if( get_word( filename )) {
      if(( from_file = fopen( filename, "r" )) == NULL ) {
           trash_rest_of_line();
         init_from_stack();
           do_error( (CELL) 159 );
        }
      else {
#if IMPLEMENTATION == OS9
           fprintf( output.stream, "\nLoading from file %s...", filename );
           push_from_fileblock( input );
           input = make_from_fileblock( filename, from_file );
           input.last_page_required = pop_data();
           goto_page( pop_data() );
#else
          if( setvbuf( from_file, NULL, _IOFBF, 10240 )) {
           trash_rest_of_line();
           init_from_stack();
           do_error( (CELL) 160 );
           }
          else {
           fprintf( output.stream, "\nLoading from file %s...", filename );
           push_from_fileblock( input );
           input = make_from_fileblock( filename, from_file );
           input.last_page_required = (int) pop_data();
           goto_page( pop_data() );
          }
#endif
      }
    }
    else
        do_error( (CELL) 147 );
}

#line 1750 "fidl.src"
void from_file( void )
{
    push_data( (CELL) (input.stream != stdin ));
}

#line 1755 "fidl.src"
void input_from( void )
{
    char filename[ FROM_FILENAME_LENGTH ];
    FILE *from_file;

    if( get_word( filename )) {
      if(( from_file = fopen( filename, "r" )) == NULL ) {
           trash_rest_of_line();
         init_from_stack();
           do_error( (CELL) 159 );
        }
      else
#if IMPLEMENTATION == OS9
          input = make_from_fileblock( filename, from_file );
#else
          if( setvbuf( from_file, NULL, _IOFBF, 8192 )) {
           do_error( (CELL) 160 );
          }
          else
           input = make_from_fileblock( filename, from_file );
#endif
    }
    else
        do_error( (CELL) 147 );
}

#line 1781 "fidl.src"
void input_from_string( void )
{
    unsigned CELL filename;
    FILE *from_file;

    filename = pop_data() + 1;
    if(( from_file = fopen( &ram[ filename ], "r" )) == NULL ) {
       trash_rest_of_line();
       init_from_stack();
       do_error( (CELL) 159 );
    }
    else
#if IMPLEMENTATION == OS9
      input = make_from_fileblock( &ram[ filename ], from_file );
#else
      if( setvbuf( from_file, NULL, _IOFBF, 8192 )) {
          do_error( (CELL) 160 );
      }
      else
         input = make_from_fileblock( &ram[ filename ], from_file );
#endif
}

#line 1804 "fidl.src"
void output_to( void )
{
    char filename[ FILENAME_LENGTH ];
    FILE *to_file;

    if( get_word( filename )) {
      if(( to_file = fopen( filename, "w" )) == NULL ) {
           trash_rest_of_line();
         init_from_stack();
           do_error( (CELL) 159 );
        }
      else
#if IMPLEMENTATION == OS9
          output = make_from_fileblock( filename, to_file );
#else
          if( setvbuf( to_file, NULL, _IOFBF, 8192 )) {
           do_error( (CELL) 160 );
          }
          else
           output = make_from_fileblock( filename, to_file );
#endif
    }
    else
        do_error( (CELL) 147 );
}

#line 1831 "fidl.src"
void output_to_string( void )
{
    unsigned CELL filename;
    FILE *to_file;

    filename = pop_data() + 1;
    if(( to_file = fopen( &ram[ filename ], "r" )) == NULL ) {
       trash_rest_of_line();
       init_from_stack();
       do_error( (CELL) 159 );
    }
    else
#if IMPLEMENTATION == OS9
      output.stream = to_file;
#else
      if( setvbuf( to_file, NULL, _IOFBF, 8192 )) {
          do_error( (CELL) 160 );
      }
      else
          output.stream = to_file;
#endif
}

#line 1855 "fidl.src"
void console( void )
{
    input = make_from_fileblock( "Console", stdin );
    output = make_from_fileblock( "Console", stdout );
}

#line 1861 "fidl.src"
void op_handle_fetch( void )
{
      data_stack[ ++sp ] = (unsigned CELL) output.stream;
}

#line 1866 "fidl.src"
void op_handle_store( void )
{
      output.stream = (FILE *) data_stack[ sp-- ];
}

#line 1871 "fidl.src"
void ip_handle_fetch( void )
{
      data_stack[ ++sp ] = (unsigned CELL) input.stream;
}

#line 1876 "fidl.src"
void ip_handle_store( void )
{
      input.stream = (FILE *) data_stack[ sp-- ];
}

#line 1881 "fidl.src"
void close_file( void )
{
    push_data( (CELL) fclose( (FILE *) pop_data() ));
}

#line 1886 "fidl.src"
void paren_save( void )
{
    char filename[ SAVE_FILENAME_LENGTH ];
    FILE *save_file;

    if( get_word( filename )) {
#if IMPLEMENTATION == OS9
      if(( save_file = fopen( filename, "w+" )) == NULL ) {
#else
      if( ( save_file = fopen( filename, "wb" )) == NULL ) {
#endif
        do_error( (CELL) 148 );
      } else {
        char header[ DICTIONARY_FILE_HEADER_LENGTH ];
        unsigned CELL bytes_written, header_bytes_written;
#ifdef CELL_IS_LONG_LONG
        sprintf( header, "%llx %llx %llx", dp, latest, voc_link );
#else
#ifdef CELL_IS_LONG
        sprintf( header, "%lx %lx %lx", dp, latest, voc_link );
#else
        sprintf( header, "%x %x %x", dp, latest, voc_link );
#endif
#endif
        header_bytes_written = fwrite( header, sizeof(char),
                                              DICTIONARY_FILE_HEADER_LENGTH,
                                              save_file );
        bytes_written = fwrite( ram, sizeof( CELL ),
                                       dp/sizeof( CELL ) + dp%sizeof( CELL ),
                             save_file );
#ifdef CELL_IS_LONG_LONG
        fprintf( output.stream, "%lld bytes written to file %s\n",
                        (header_bytes_written+bytes_written*CELL_SIZE),
                        filename );
#else
#ifdef CELL_IS_LONG
        fprintf( output.stream, "%ld bytes written to file %s\n",
                        (header_bytes_written+bytes_written*CELL_SIZE),
                        filename );
#else
        fprintf( output.stream, "%d bytes written to file %s\n",
                        (header_bytes_written+bytes_written*CELL_SIZE),
                        filename );
#endif
#endif
      }
    } else {
        do_error( (CELL) 147 );
    }
}

#line 1938 "fidl.src"
void tick( void )
{
    unsigned CELL lfa;
    char word[ WORD_LENGTH ];

    if( get_word( word ))
      if( (lfa = defined_word( word )))
          push_data( execution_token( lfa ));
      else
            do_error( (CELL) 0 );
    else
        do_error( (CELL) 145 );
}

#line 1952 "fidl.src"
void comment( void )
{
    trash_rest_of_line();
}

#line 1957 "fidl.src"
void user_base( void )
{
    push_data( (CELL) USER_BASE );
}

#line 1963 "fidl.src"
void semi_page( void )
{
    if( input.stream != stdin ) {
      fprintf( output.stream, " Done!\n" );
      fclose( input.stream );
      input = pop_from_fileblock();
      if( input.stream == stdin ) prompt();
    }
}

#line 1975 "fidl.src"
void query_error( void )
{
      unsigned CELL error_number;

      error_number = data_stack[ sp-- ];
      if (data_stack[ sp-- ]) do_error( error_number);
}

#line 1985 "fidl.src"
void to_body( void )
{
      data_stack[ sp ] += CELL_SIZE;
}

#line 1990 "fidl.src"
void body_from( void )
{
      data_stack[ sp ] -= CELL_SIZE;
}

#line 1996 "fidl.src"
void name_to_link( void )
{
    push_data( nfa_to_lfa( pop_data() ));
}

#line 2002 "fidl.src"
void link_to_name( void )
{
    push_data( lfa_to_nfa( pop_data() ));
}

#line 2008 "fidl.src"
void to_link( void )
{
    push_data( nfa_to_lfa( cfa_to_nfa( pop_data()) ));
}

#line 2013 "fidl.src"
void to_name( void )
{
    push_data( cfa_to_nfa( pop_data() ));
}

#line 2018 "fidl.src"
void link_from( void )
{
    push_data( nfa_to_cfa( lfa_to_nfa( pop_data() )));
}

#line 2023 "fidl.src"
void name_form( void )
{
    push_data( nfa_to_cfa( pop_data() ));
}

#line 2030 "fidl.src"
void number_of_threads( void )
{
/*
   push_data( (CELL) MAX_THREADS );
*/
      data_stack[ ++sp ] = MAX_THREADS;
}

#line 2038 "fidl.src"
void number_of_vocs( void )
{
/*
    push_data( (CELL) MAX_VOCS );
*/
      data_stack[ ++sp ] = MAX_VOCS;
}

#line 2047 "fidl.src"
void call_os( void )
{
    unsigned CELL command_string;

    command_string = pop_data();
    system( &ram[ command_string+1 ] );
}

#line 2056 "fidl.src"
void exit_from_this_word( void )
{
#ifdef CWEED
    if( !(kill_switch = ((CELL) rp == -1)))
      ip = pop_return();
#else
    ip = return_stack[ rp-- ];
#endif
}

#line 2067 "fidl.src"
void cell_size( void )
{
    data_stack[ ++sp ] = CELL_SIZE;
}

#line 2072 "fidl.src"
void plus_cell( void )
{
    data_stack[ sp ] += CELL_SIZE;
}

#line 2077 "fidl.src"
void minus_cell( void )
{
     data_stack[ sp ] -= CELL_SIZE;
}

#line 2082 "fidl.src"
void star_cell( void )
{
    data_stack[ sp ] = data_stack[ sp ] * CELL_SIZE;
}

#line 2087 "fidl.src"
void slash_cell( void )
{
    data_stack[ sp ] = data_stack[ sp ] / CELL_SIZE;
}

#line 2092 "fidl.src"
void cells( void )
{
    data_stack[ sp ] = data_stack[ sp ] * CELL_SIZE;
}

#line 2097 "fidl.src"
void even_alignement( void )
{
/*
    push_data( cell_aligned( pop_data() ));
*/
      data_stack[ sp ] = cell_aligned( data_stack[ sp ] );
}

#line 2106 "fidl.src"
void paren_quotes_quotes( void )
{
/*
    unsigned CELL length;

    push_data( ip );
    length = ram[ ip ];
    ip = cell_aligned( length + 1 + ip );
*/
      data_stack[ ++sp ] = ip;
      ip = cell_aligned( ram[ ip ] + 1 + ip );
}

#line 2122 "fidl.src"
void quotes_quotes( void )
{
    char string[ LINE_LENGTH ];

    get_string( string, '\"' );
    if( compiling ) {
      comma_word( (CELL) prim_paren_quotes_quotes );
      dp = quotes_comma_string( string, dp );
    }
    else {
      comma_word( (CELL) prim_paren_quotes_quotes );
        push_data( dp );
      dp = quotes_comma_string( string, dp );
    }
}

#line 2139 "fidl.src"
void paren_dot_quotes( void )
{
    unsigned CELL *cell;

    fprintf( output.stream, "%s", &ram[ ip+1 ] );
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = (*cell) + (unsigned CELL) strlen( &ram[ ip+1 ] );
    ip =  cell_aligned( ram[ip]+1+ip );
}

#line 2150 "fidl.src"
void dot_quotes( void )
{
    char string[ LINE_LENGTH ];
    unsigned CELL *cell;

    get_string( string, '\"' );
    if( compiling ) {
      comma_word( (CELL) prim_paren_dot_quotes );
      dp = quotes_comma_string( string, dp );
    } else {
      fprintf( output.stream, "%s", string );
      cell = (unsigned CELL *) &ram[ OUT ];
      (*cell) = (*cell) + (unsigned CELL) strlen( string );
    }
}

#line 2166 "fidl.src"
void paren_s_quotes( void )
{
    int len;

    len=ram[ip] ;

//    printf("len=%d\n",len);
    ip++;

    push_data( ip );
    push_data( len );

    ip =  cell_aligned( ip+len );
}

#line 2181 "fidl.src"
void s_quotes( void )
{
    char string[ LINE_LENGTH ];
    unsigned CELL *cell;
    int len;

    get_string( string, '\"' );

    if (compiling ) {
//        printf("Compile :%s:\n",string);
        comma_word( (CELL) prim_paren_s_quotes );
        dp = quotes_comma_string( string, dp );
    } else {
        len=strlen(string);
        strncpy(&ram[PAD],string, len);

        push_data( PAD );
        push_data( len );

//        printf("Interpret\n");
//        printf("... behaviour undefined by ANS Standard.\n");
    }
}

#line 2205 "fidl.src"
void compiler_off( void )
{
    compiling = 0;
}

#line 2210 "fidl.src"
void compiler_on( void )
{
    compiling = 1;
}

#line 2215 "fidl.src"
void quotes_comma( void )
{
    char string[ LINE_LENGTH ];

    get_string( string, '\"' );
    dp = quotes_comma_string( string, dp );
}

#line 2225 "fidl.src"
void paren_carriage_return( void )
{
    unsigned CELL * cell;

    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell) = 0;
    fprintf( output.stream, "\n" );
}

#line 2235 "fidl.src"
void immediate( void )
{
    ram[ latest ] |= IMMEDIATE_MASK;
}

#line 2240 "fidl.src"
void state_fetch( void )
{
/*
    push_data( compiling );
*/
      data_stack[ ++sp ] = compiling;
}

#line 2248 "fidl.src"
void state_store( void )
{
/*
     compiling = pop_data();
*/
      compiling = data_stack[ sp-- ];
}

#line 2257 "fidl.src"
void csp_store( void )
{
/*
    current_sp = pop_data();
*/
      current_sp = data_stack[ sp-- ];
}

#line 2265 "fidl.src"
void store_csp( void )
{
    current_sp = sp;
}

#line 2270 "fidl.src"
void fetch_csp( void )
{
/*
    push_data( current_sp );
*/
      data_stack[ ++sp ] = current_sp;
}

#line 2278 "fidl.src"
void query_csp( void )
{
    if( current_sp != sp ) do_error( (CELL) 20 );
}

#line 2283 "fidl.src"
void query_exec( void )
{
    if( !compiling ) do_error( (CELL) 18 );
}

#line 2291 "fidl.src"
void paren_type( void )
{
/*
    unsigned CELL junk, string_address, *cell;

    junk = pop_data();
    string_address = pop_data();
    fprintf( output.stream, "%s", &ram[ string_address ] );
    cell = (unsigned CELL *) &ram[ OUT ];
    (*cell)+= strlen( &ram[ string_address ] );
*/
      unsigned CELL address, len, *cell;
      char temp[128];

      len = data_stack[ sp-- ];
      address = data_stack[ sp-- ];
      len = (len<127 ? len : 127 );
      memcpy( temp, &ram[ address ], len );
      temp[ len ] = '\0';
      fprintf( output.stream, "%s", temp );
      cell = (unsigned CELL *) &ram[ OUT ];
      (*cell) += len;
}

#line 2316 "fidl.src"
void show_prompt( void )
{
    prompt();
}

#line 2321 "fidl.src"
void compile_lit( void )
{
    compile_literal( pop_data() );
}

#line 2327 "fidl.src"
void string_plus( void )
{
    unsigned CELL string1_address, string2_address;
    char *result, *string1, *string2;

    string1_address = pop_data();
    string2_address = pop_data();
    string1 = (char *) &ram[ string1_address+1 ];
    string2 = (char *) &ram[ string2_address+1 ];
    result = strcat( string1, string2 );
    ram[ string1_address ] = (char) strlen( string1 );
}

#line 2341 "fidl.src"
void memory_top( void )
{
      data_stack[ ++sp ] = (CELL) RAM_TOP;
}

#line 2347 "fidl.src"
void terminal_input_buffer( void )
{
      data_stack[ ++sp ] = (CELL) TIB ;
}

#line 2353 "fidl.src"
void init_fence( void )
{
      data_stack[ ++sp ] = (CELL) (INIT_FENCE) ;
}

#line 2359 "fidl.src"
void root_voc( void )
{
      data_stack[ ++sp ] = (CELL) (ROOT_VOC) ;
}

#line 2365 "fidl.src"
void width( void )
{
      data_stack[ ++sp ] = (CELL) (WIDTH) ;
}

#line 2371 "fidl.src"
void to_in( void )
{
      data_stack[ ++sp ] = (CELL) (TO_IN) ;
}

#line 2377 "fidl.src"
void out( void )
{
      data_stack[ ++sp ] = (CELL) (OUT) ;
}

#line 2383 "fidl.src"
void span( void )
{
      data_stack[ ++sp ] = (CELL) (SPAN) ;
}

#line 2389 "fidl.src"
void hld( void )
{
      data_stack[ ++sp ] = (CELL) (HLD) ;
}

#line 2395 "fidl.src"
void base( void )
{
      data_stack[ ++sp ] = (CELL) (BASE) ;
}

#line 2401 "fidl.src"
void dpl( void )
{
      data_stack[ ++sp ] = (CELL) (DPL) ;
}

#line 2407 "fidl.src"
void hash_tib( void )
{
      data_stack[ ++sp ] = (CELL) (HASH_TIB) ;
}

#line 2413 "fidl.src"
void hash_l( void )
{
      data_stack[ ++sp ] = (CELL) (HASH_L) ;
}

#line 2419 "fidl.src"
void tab_width( void )
{
      data_stack[ ++sp ] = (CELL) (TAB_WIDTH) ;
}

#line 2425 "fidl.src"
void hash_d( void )
{
      data_stack[ ++sp ] = (CELL) (HASH_D) ;
}

#line 2431 "fidl.src"
void line_number( void )
{
      data_stack[ ++sp ] = (CELL) (LINE_NUMBER) ;
}

#line 2437 "fidl.src"
void page_number( void )
{
      data_stack[ ++sp ] = (CELL) (PAGE_NUMBER) ;
}

#line 2443 "fidl.src"
void pad( void )
{
      data_stack[ ++sp ] = (CELL) (PAD) ;
}

#line 2449 "fidl.src"
void current( void )
{
      data_stack[ ++sp ] = (CELL) (CURRENT_AREA) ;
}

#line 2455 "fidl.src"
void context( void )
{
      data_stack[ ++sp ] = (CELL) (CONTEXT_AREA) ;
}

#line 2460 "fidl.src"
void word_buff( void )
{
      data_stack[ ++sp ] = (CELL) (WORD_BUFF) ;
}

#line 2466 "fidl.src"
void word( void )
{
    char delimiter;
    int found_string;

    delimiter = (char) pop_data();
    found_string = get_string( (&ram[ WORD_BUFF+1 ]), delimiter );
    ram[ WORD_BUFF ] = strlen((&ram[ WORD_BUFF+1 ]));
    word_buff();
}

#line 2479 "fidl.src"
void find( void )
{
    unsigned CELL string_address, lfa;

    string_address = pop_data();
    char tmp[128];

    memset( tmp, '\0', 128 );
//    bzero( tmp,128);

    strncpy(tmp, &ram[ string_address +1 ], ram[string_address] );


//   if( (lfa = defined_word( (&ram[ string_address + 1 ])))) {
    if( (lfa = defined_word( ( tmp ))) ) {
      if( is_immediate( lfa_to_nfa( lfa ))) {
          int compile_status = compiling;

          compiling = FALSE;
             push_data( execution_token( lfa ));
          compiling = compile_status;
          push_data( (CELL) 1);
      }
      else {
          push_data( execution_token( lfa ));
          push_data( (CELL) -1);
      }

    } else {
        push_data( string_address );
        push_data( (CELL) 0 );
    }
}

#line 2513 "fidl.src"
void integer_query( void )
{
    unsigned CELL string_address, value;

    string_address = pop_data() + 1;
    if( number( &ram[ string_address ], 0, &value )) {
        push_data( value );
        push_data( (CELL) 1 );
    }
    else {
        push_data( (CELL) 0 );
    }
}

#line 2527 "fidl.src"
void literal( void )
{
    compile_literal( pop_data());
}

#line 2532 "fidl.src"
void number_of_literals( void )
{
    CELL i, count;

    count = (CELL) pop_data();
    for( i=0; i<count; i++ ) literal();
}

#line 2540 "fidl.src"
void eolchar_con( void )
{
      data_stack[ ++sp ] = (CELL) (EOLCHAR_CON) ;
}

#line 2545 "fidl.src"
void ignchar_con( void )
{
      data_stack[ ++sp ] = (CELL) (IGNCHAR_CON) ;
}

#line 2550 "fidl.src"
void query( void )
{
   if( get_line()==EOF )
        do_error( (CELL) 155 );

}

#line 2557 "fidl.src"
void forth_error( void )
{
    do_error( pop_data());
}

#line 2562 "fidl.src"
void forth_message( void )
{
    show_this_error( pop_data());
}

#line 2567 "fidl.src"
void io_initialise( void )
{
    init_io();
}

#line 2572 "fidl.src"
void upper_case_string( void )
{
    unsigned CELL string_address;

    string_address = pop_data() + 1;
    strupper( &ram[ string_address ] );
}

#line 2580 "fidl.src"
void lower_case_string( void )
{
    unsigned CELL string_address;

    string_address = pop_data() + 1;
    strlower( &ram[ string_address ] );
}

#line 2588 "fidl.src"
void left_paren( void )
{
    char junk_line[ LINE_LENGTH ];

    get_string( junk_line, ')' );
}

#line 2595 "fidl.src"
void paren_forget( void )
{
    unsigned CELL nfa, dictionary_fence, this_voc;

    nfa = pop_data();
    init_fence();
    fetch();
    dictionary_fence = pop_data();
    if( nfa < dictionary_fence ) do_error( (CELL) 21);
    else
        forget_me( nfa );
}

#line 2608 "fidl.src"
void forget( void )
{
    unsigned CELL lfa;
    char word[ WORD_LENGTH ];

    if( get_word( word ))
        if( (lfa = defined_word( word ))) {
            push_data( lfa_to_nfa( lfa ));
            paren_forget();
        }
        else
            do_error( (CELL) 0 );
    else
        do_error( (CELL) 145 );
}

#line 2624 "fidl.src"
void create_path_pcb( void )
{
    unsigned CELL *cell, pcb, filename;
    FILE * stream;

    pcb = pop_data();
    filename = pcb + CELL_SIZE + 1;
    stream = fopen( &ram[ filename ], "w+" );
    if( stream == NULL )
      push_data( (CELL) -1 );
    else
#if IMPLEMENTATION == OS9
      {
          cell = (unsigned CELL *) &ram[ pcb ];
          *cell = (unsigned CELL) stream;
          push_data( (CELL) 0 );
      }
#else
      if( setvbuf( stream, NULL, _IOFBF, 1024 )) {
          do_error( (CELL) 160 );
      }
      else {
          cell = (unsigned CELL *) &ram[ pcb ];
          *cell = (unsigned CELL) stream;
          push_data( (CELL) 0 );
      }
#endif
}

#line 2653 "fidl.src"
void open_path_pcb( void )
{
    unsigned CELL *cell, pcb, filename;
    FILE * stream;

    pcb = pop_data();
    filename = pcb + CELL_SIZE + 1;
    stream = fopen( &ram[ filename ], "r+" );
    if( stream == NULL )
      push_data( (CELL) -1 );
    else
#if IMPLEMENTATION == OS9
      {
          cell = (unsigned CELL *) &ram[ pcb ];
          *cell = (unsigned CELL) stream;
          push_data( (CELL) 0 );
      }
#else
      if( setvbuf( stream, NULL, _IOFBF, 1024 )) {
          do_error( (CELL) 160 );
      }
      else {
          cell = (unsigned CELL *) &ram[ pcb ];
          *cell = (unsigned CELL) stream;
          push_data( (CELL) 0 );
      }
#endif
}

#line 2682 "fidl.src"
void filtered_io( void )
{
#if IMPLEMENTATION == MicrosoftC
    _fmode = O_TEXT;
#endif
}

#line 2689 "fidl.src"
void un_filtered_io( void )
{
#if IMPLEMENTATION == MicrosoftC
    _fmode = O_BINARY;
#endif
}

#line 2696 "fidl.src"
void read_path( void )
{
    unsigned CELL buffer, length, handle, items_read;

    handle = pop_data();
    length = pop_data();
    buffer = pop_data();
    items_read = (CELL) fread( &ram[ buffer],
                        sizeof( char ), (int) length,
                        (FILE *) handle );
    push_data( items_read );
    push_data( (CELL) 0 );
}

#line 2710 "fidl.src"
void write_path( void )
{
    unsigned CELL buffer, length, handle, items_written;

    handle = pop_data();
    length = pop_data();
    buffer = pop_data();
    items_written = (CELL) fwrite( &ram[ buffer],
                         sizeof( char ), (int) length,
                         (FILE *) handle );
    push_data( items_written );
    push_data( (CELL) 0 );
}

#line 2724 "fidl.src"
void seek_path( void )
{
    CELL offset;
    unsigned CELL handle;

    handle = pop_data();
    offset = pop_data();
#if IMPLEMENTATION == SUN
    push_data( (CELL) fseek( (FILE *) handle, offset, 0 ));
#else
#if IMPLEMENTATION == OS9
    push_data( (CELL) fseek( (FILE *) handle, offset, 0 ));
#else
#if IMPLEMENTATION == MicrosoftC
    push_data( (CELL) fseek( (FILE *) handle, offset, SEEK_SET ));
#else
#if IMPLEMENTATION == Linux || IMPLEMENTATION == Linux64
    push_data( (CELL) fseek( (FILE *) handle, offset, 0 ));
#else
#if IMPLEMENTATION == TurboC
    push_data( (CELL) fseek( (FILE *) handle, offset, SEEK_SET ));
#else
#if IMPLEMENTATION == MinGW64
    push_data( (CELL) fseek( (FILE *) handle, offset, SEEK_SET ));
#else
    #error No Implementation Specified
#endif
#endif
#endif
#endif
#endif
#endif
}

#line 2758 "fidl.src"
void delete_path( void )
{
    unsigned CELL *cell, pcb, filename;
    char command_string[ MAX_COMMAND_LINE_LENGTH ], *result;

    pcb = pop_data();
    filename = pcb + CELL_SIZE + 1;
    cell = (unsigned CELL *) &ram[ pcb ];
    *cell = (CELL) -1;
    result = strcpy( command_string, SYSTEM_DELETE_COMMAND );
    result = strcat( command_string, &ram[ filename ] );
    push_data( (CELL) system( command_string ));
}

#line 2772 "fidl.src"
void v_find( void )
{
    unsigned CELL * thread_link, voc, lfa, name;
    int thread_number, name_length;

    voc = data_stack[ sp-- ];
    name = data_stack[ sp ];
    if( (lfa=defined_in_this_voc( &ram[ name+1 ], voc )))
    { data_stack[ sp ] = execution_token( lfa );
      if( is_immediate( lfa_to_nfa( lfa )))
          data_stack[ ++sp ] = (signed CELL) 1;
      else
          data_stack[ ++sp ] = (signed CELL) -1;
    }
    else
      data_stack[ ++sp ] = (signed CELL) 0;
}

#line 2790 "fidl.src"
void fill( void )
{
    char byte, *junk;
    unsigned CELL length, address;

    byte = (char) data_stack[ sp-- ];
    length = data_stack[ sp-- ];
    address = data_stack[ sp-- ];
    memset( (char *) &ram[ address ], byte, length );
}

#line 2801 "fidl.src"
void query_stack( void )
{
    if( !(( sp>=0 && sp<DATA_STACK_TOP) || sp==-1 ))
      do_error( (CELL) 1 );
}

#line 2810 "fidl.src"
void increment( void )
{
    unsigned CELL * cell;

    cell = (unsigned CELL *) &ram[ data_stack[ sp-- ] ];
    *cell += 1;
}

#line 2821 "fidl.src"
void decrement( void )
{
    unsigned CELL * cell;

    cell = (unsigned CELL *) &ram[ data_stack[ sp-- ] ];
    *cell -= 1;
}

#line 2832 "fidl.src"
void s_to_d( void )
{
    if  ((signed CELL) data_stack[ sp ] < (signed CELL) 0)
    {
        data_stack[ ++sp ] = TRUE;
    }
    else
    {
        data_stack[ ++sp ] = FALSE;
    }
}

#line 2848 "fidl.src"
void on( void )
{
    unsigned CELL * cell;

    cell = (unsigned CELL *) &ram[ data_stack[ sp-- ] ];

    *cell = TRUE;
}

#line 2857 "fidl.src"
void off( void )
{
    unsigned CELL * cell;

    cell = (unsigned CELL *) &ram[ data_stack[ sp-- ] ];

    *cell = FALSE;
}

#line 2870 "fidl.src"
void f_bounds( void )
{
    unsigned CELL address;
    unsigned CELL len;

    len = data_stack[ sp ];
    address = data_stack[ sp-1 ];
    data_stack[ sp-1 ] = address+len;
    data_stack[ sp ] = address;
}

#line 2885 "fidl.src"
void f_count( void )
{
    unsigned CELL address;
    unsigned char len;

    address = data_stack[ sp ];
    len = ram[ address++ ];
    data_stack[ sp ] = address;
    data_stack[ ++sp ] = (unsigned CELL) len ;
}

#line 2900 "fidl.src"
void f_digit( void )
{
    signed CELL data, base;

    base = data_stack[ sp ];
    data = data_stack[ sp-1 ];
    data -= '0';
    if (data<0)
       goto not_digit;
    if (data>9)
    {
       data -= 7;
       if (data<10)
          goto not_digit;
    }
    if  (data>=base)
        goto not_digit;
    data_stack[ sp-1 ] = data;
    data_stack[ sp ] = TRUE;
    return;
not_digit:
    data_stack[ --sp ] = FALSE;
}

#line 2928 "fidl.src"
void f_upc( void )
{
      unsigned char byte;

      byte = (unsigned char) data_stack[ sp ];
      if ((byte>='a') && (byte<='z'))
           byte = byte & 223;
      data_stack[ sp ] = (unsigned CELL) byte;
}

#line 2938 "fidl.src"
void f_upper( void )
{
      unsigned CELL address;
      unsigned CELL len, i;
      unsigned char byte;

      len = data_stack[ sp-- ];
      address = data_stack[ sp-- ];
      for( i=0; i<len; i++ )
      {
        byte = ram[ address ];
        if ((byte>='a') && (byte<='z'))
             byte = byte & 223;
        ram[ address++ ] = byte;
      }
}

#line 2960 "fidl.src"
void f_cmove( void )
{
      unsigned CELL source, dest, len, i;

      len = data_stack[ sp-- ];
      dest = data_stack[ sp-- ];
      source = data_stack[ sp-- ];
      for (i=0; i<len; i++)
        ram[ dest++ ] = ram[ source++ ];
}

#line 2971 "fidl.src"
void f_cmove_up( void )
{
      unsigned CELL source, dest, len, i;

      len = data_stack[ sp-- ];
      dest = data_stack[ sp-- ] + len;
      source = data_stack[ sp-- ] + len;
      for (i=0; i<len; i++)
        ram[ --dest ] = ram[ --source ];
}

#line 2985 "fidl.src"
void slash_string( void )
{
      unsigned CELL n;

      n = data_stack[ sp-- ];
      data_stack[ sp ] -= n;
      data_stack[ sp-1 ] += n;
}

#line 2995 "fidl.src"
void set_error_file( void )
{
    unsigned CELL string_address;

    string_address = pop_data() + 1;
    strcpy( error_filename, &ram[ string_address ] );
    init_error_handler();
}

#line 3006 "fidl.src"
void true( void )
{
    push_data((CELL) -1);
}

#line 3013 "fidl.src"
void false( void )
{
    push_data((CELL) 0);
}

#line 3020 "fidl.src"
void cell_to_bytes( void )
{
    data_stack[ sp ] = data_stack[ sp ] * sizeof(CELL);
}

#line 3028 "fidl.src"
void ath_os( void )
{
#if IMPLEMENTATION == MinGW64
    int os = OS_WIN64;
#else
    int res;
    int os=0;
    struct utsname buf;

    res = uname(&buf);

    if (strcasecmp(buf.sysname, "linux") == 0) {
        os = OS_LINUX;
    } else if (strcasecmp(buf.sysname, "darwin") == 0) {
        os = OS_DARWIN;
    } else if (strcasecmp(buf.sysname, "uClinux") == 0) {
        os = OS_UCLINUX;
    }  else if (strcasecmp(buf.sysname, "QNX") == 0) {
        os = OS_QNX;
    }
#endif
    push_data( os );
}

#line 3052 "fidl.src"
void ath_macosq( void )
{
    int tmp;

    ath_os();

    push_data( OS_DARWIN );
    equals();
}

#line 3062 "fidl.src"
void ath_linuxq( void )
{
    int tmp;

    ath_os();
    push_data( OS_LINUX );
    equals();
}

#line 3071 "fidl.src"
void ath_uclinuxq( void )
{
    int tmp;

    ath_os();
    push_data( OS_UCLINUX );
    equals();
}

#line 3080 "fidl.src"
void ath_qnxq( void )
{
    int tmp;

    ath_os();
    push_data( OS_QNX );
    equals();
}

#line 3089 "fidl.src"
void ath_cpu( void )
{
#if IMPLEMENTATION == MinGW64
    int cpu = CPU_AMD64;
#else
    int res;
    int cpu=0;
    struct utsname buf;

    res = uname(&buf);

    if ((strcasecmp(buf.machine, "i686") == 0) || (strcasecmp(buf.machine, "i386") == 0) || (strcasecmp(buf.machine, "x86pc") == 0) )
    {
        cpu = CPU_X86;
    } else if ( (strcasecmp(buf.machine, "Power Macintosh") == 0) || (strcasecmp(buf.machine, "ppc") == 0) )
    {
        cpu = CPU_PPC;
    } else if (strcasecmp(buf.machine, "armv5tel") == 0) {
        cpu = CPU_ARM;
    } else if (strcasecmp(buf.machine, "m68knommu") == 0) {
        cpu = CPU_COLDFIRE;
    } else if (strcasecmp(buf.machine, "mips") == 0) {
        cpu = CPU_MIPS;
    } else if (strcasecmp(buf.machine, "sh4a") == 0) {
        cpu = CPU_SH4A;
    }
#endif
    push_data( cpu );
}

#line 3119 "fidl.src"
void ath_tst( void )
{
    unsigned int t;

    t = TIB + ram[TO_IN];
    (ram[TO_IN])++;
    compile_literal( ram[t] );
}

#line 3128 "fidl.src"
void d_plus( void )
{
// D+ ( al ah bl bh -- sl sh
  unsigned CELL ah, al, bh, bl, sh, sl;

  bh = pop_data();
  bl = pop_data();
  ah = pop_data();
  al = pop_data();

  sh = 0;
  sl = al + bl;
  if( sl < bl ) sh = 1; /* Carry */
  sh += ah + bh;

  push_data( sl );
  push_data( sh );
}

#line 3147 "fidl.src"
void d_minus( void )
{
// D- ( al ah bl bh -- sl sh
  unsigned CELL ah, al, bh, bl, sh, sl;

  bh = pop_data();
  bl = pop_data();
  ah = pop_data();
  al = pop_data();

  sh = 0;
  sl = al - bl;
  if( al < bl ) sh = 1; /* Borrow */
  sh = ah - bh - sh;

  push_data( sl );
  push_data( sh );
}

#line 3166 "fidl.src"
void um_star( void )
{
#ifndef NO_2CELL_TYPE
/*
    WARNING THIS IS A HACK!! IT NEEDS TESTING ON AS MANY PLATFORMS
    AS POSSIBLE.
*/
    unsigned TWO_CELL r,lowmask;
    unsigned CELL a,b;

    a = pop_data();
    b = pop_data();

    r = (TWO_CELL)a * (TWO_CELL)b;

    lowmask = (1 << NBITS)-1;	// bit mask to extract low cell

    push_data ( (unsigned CELL) (r & lowmask) );
    push_data ( (unsigned CELL) r >> NBITS );
#endif

#ifdef NO_2CELL_TYPE
#warning "NO_2CELL_TYPE in UM*"
    CELL ahi, alo, bhi, blo; /* input parts */
    CELL lo, hi, temp;

/* Get values from stack. */
    ahi = pop_data();
    bhi = pop_data();

/* Break into hi and lo parts. */
    alo = LO_HALF(ahi);
    ahi = HI_HALF(ahi);
    blo = LO_HALF(bhi);
    bhi = HI_HALF(bhi);

    lo = 0;
    hi = 0;
/* higher part: ahi * bhi */
    hi += ahi * bhi;
/* middle (overlapping) part: ahi * blo */
    temp = ahi * blo;
    lo += LO_HALF(temp);
    hi += HI_HALF(temp);
/* middle (overlapping) part: alo * bhi  */
    temp = alo * bhi;
    lo += LO_HALF(temp);
    hi += HI_HALF(temp);
/* lower part: alo * blo */
    temp = alo * blo;
/* its higher half overlaps with middle's lower half: */
    lo += HI_HALF(temp);
/* process carry: */
    hi += HI_HALF(lo);
    lo = LO_HALF(lo);
/* combine lower part of result: */
    lo = (lo << HNBITS) + LO_HALF(temp);

    push_data(lo);
    push_data(hi);
#endif
}

#line 3249 "fidl.src"
void ath_um_slash_mod( void )
{
#ifndef NO_2CELL_TYPE
    unsigned TWO_CELL r;
    unsigned int divisor;
    unsigned int quot,mod;

    divisor=(unsigned int)pop_data();

    r=(unsigned int)pop_data(); // most sig word of double
    r=r << 32 ;
    r += (unsigned int)pop_data();

    quot = ( r / divisor );
    mod =  (r % divisor);

    push_data( mod );
    push_data( quot );
#endif

#ifdef NO_2CELL_TYPE
/* UM/MOD ( al ah bdiv -- rem q ) */
    unsigned CELL ah,al, q,di, bl,bh, sl,sh;

    bh = pop_data();
    bl = 0;
    ah = pop_data();
    al = pop_data();
    q = 0;
    for( di=0; di<NBITS; di++ )
    {
        if( !DULT(al,ah,bl,bh) ) {
	    sh = 0;
            sl = al - bl;
            if( al < bl ) sh = 1; /* Borrow */
            sh = ah - bh - sh;
            ah = sh;
            al = sl;
            q |= 1;
        }
        q = q << 1;
        bl = (bl >> 1) | (bh << (NBITS-1));
        bh = bh >> 1;
    }
    if( !DULT(al,ah,bl,bh) ) {
        al = al - bl;
        q |= 1;
    }

    push_data( al );		/* rem */
    push_data( q );		/* quot */
#endif
}

#line 3379 "fidl.src"
void ath_char_plus( void )
{
      data_stack[ sp ] += (sizeof(char));

}

#line 3385 "fidl.src"
void ath_chars_plus( void )
{
    int c;

    c= pop_data() * sizeof(char) ;
    data_stack[ sp ] += c;

}

#line 3394 "fidl.src"
void ath_chars( void )
{
    data_stack[ sp ] = data_stack[ sp ] * sizeof(char );
}

#line 3399 "fidl.src"
void ath_state( void )
{
/*
 * ATH This is a hack.
 * and there has got o be a better way of doing this . . .
 *
 * Copy the current compile state into the user variable COMPILE_STATE
 * from the C variable compiling.
*/

    unsigned CELL *ptr;

//    printf("%d compiling is %d\n",COMPILE_STATE,compiling);

    ptr = &ram [ COMPILE_STATE ];
    *ptr = (CELL) compiling;

//    (unsigned CELL *)ram [ COMPILE_STATE ] = (CELL) compiling;

    push_data( (CELL) COMPILE_STATE );

}

#line 3422 "fidl.src"
void ath_ath( void )
{
    printf("HERE\n");
}

