\ Structs
\
\ RFC 16/10/90
\
\ The following defines those structs which are used the CGI interface.
\ These are constructed using the siomple record wordset defined below.

\ Simple Record Wordset.
\
\ This wordset allow the contruction of simple record structures.
\ The key to reading these structure is to remeber Brodie's
\ "Thinking Forth" notation- a slash infront of a word is defined
\ as "bytes per". /float is read "bytes per float".

\ A rec definintion has the form rec{ <fields> }rec <rec-size-name>
\ where rec-size-name is a words beginning with a slash.
\ fields is a set of field names defined by:
\  <size> field <field-name>
\
\ Thus:
\   /float field x
\
\ defines a field x of length bytes-per-float (4)
\
\
\ Record Constuctors
\
\ After Each Rec{ }Rec Definition a constructor word is defined.
\ This has a name of similar to that of the preceding
\ <rec-size-name> but the slash is repalced with a colon (pronounced
\ "define"), again after Brodie.
\


variable offset#

: rec{ \ --
  offset# off ;

: }rec \ --; <word in input>
  offset# @ 
  constant ;


: field
  create     \ field-size --;<fieldname in input>
       offset# @ ,
       offset# +! 
  does>      \ 'record -- 'field
       @ + ;


\ Standard type sizes.

1 constant /char
4 constant /float
4 constant /int
4 constant /enum
4 constant /cell
4 constant /error

\ Struct Definitions
rec{

/enum  field line_type-Cbunatt
/float field line_width-Cbunatt
/int   field line-colour
/enum  field marker_type-Cbunatt
/float field marker_size-Cbunatt
/int   field marker_color-Cbunatt
/enum  field interior_style-Cbunatt
/int   field hatch_index-Cbunatt
/int   field pattern_index-Cbunatt
/int   field fill_color-Cbunatt
/enum  field perimeter_type
/float field perimeter_width-Cbunatt
/int   field perimeter_color
/int   field text_font
/enum  field text_precision-Cbunatt
/float field character_expansion
/float field character_spacing-Cbunatt
/int   field text_color-Cbunatt

}rec               /Cbunatt

: :Cbunatt \ --; <word in input>
  create /Cbunatt allot ;


rec{
/cell field *ra
/cell field *ga
/cell field *ba
/int  field n-Ccentry
}rec /Ccentry

: :Ccentry \ --; <word in input>
  create /Ccentry allot ;



rec{
/int field x-Ccoor
/int field y-Ccoor
}rec  /Ccoor

: :Ccoor \ --; <word in input>
  create /Ccoor allot ;


rec{
/cell field *ptlist
/int field n-Ccoorlist
}rec /Ccoorlist

: :Ccoorlist \ --; <word in input>
  create /Ccoorlist allot ;




rec{
/cell field *upper
/cell field *lower
}rec /Ccoorpair

: :Ccoorpair \ --;<word in input>
  create /Ccoorpair  allot ;


rec{
/int field n-Cechotypelst
/cell field *elements
/cell field *echos-Cechotypelst
}rec /Cechotypelst

: :Cechotypelst \ --;<word in input>
  create /Cechotypelst allot ;


rec{
/cell field *echos-Cechostatelst
/int  field n-Cechostatelst
}rec /Cechostatelst

: :Cechostatelst \ --;<word in input>
  create /Cechostatelst allot ;

rec{
/int field segid
/int field pickid
}rec /Cpick

: :Cpick \ --;<word in input>
  create /Cpick allot ;




rec{
/cell  field  *xypt
/cell  field *points
/float field val
/int   field choice
/cell  field *string
/cell  field *pick
}rec /Cinrep

: :Cinrep \ --;<word in input>
  create /Cinrep allot ;



rec{
/cell field *echos-Cechodatalst
/int  field n-Cechodatalst
}rec /Cechodatalst

: :Cechodatalst \ --;<word in input>
  create /Cechodatalst allot ;



rec{
/enum field style-Cfillatt
/enum field visible
/int  field color-Cfillatt
/int  field hatch_index-Cfillatt
/int  field pattern_index-Cfillatt
/int  field index-Cfillatt
/enum field pstyle
/float field pwidth
/int   field pcolor
}rec /Cfillatt

: :Cfillatt \ --;<word in input>
  create /Cfillatt allot ;



rec{
/int field n-Cflaglist
/cell field  *num
/cell field  *value
}rec /Cflaglist

: :Cflaglist \ --;<word in input>
  create /Cflaglist allot ;





rec{
/enum  field style-Clinatt
/float field width-Clinatt
/int   field color-Clinatt
/int   field index-Clinatt
}rec /Clinatt

: :Clinatt \ --;<word in input>
  create /Clinatt allot ;




\ typedef struct pixrect Cpixrect;

rec{
/enum  field type-Cmarkatt
/float field size
/int   field color-Cmarkatt
/int   field index-Cmarkatt
}rec /Cmarkatt


: :Cmarkatt \ --;<word in input>
  create /Cmarkatt allot ;




rec{
/int  field     cur_index
/int  field     row
/int  field     column
/int  field     *colorlist
/cell field     *point
/int  field     dx
/int  field     dy
}rec /Cpatternatt

: :Cpatternatt \ --;<word in input>
  create /Cpatternatt allot ;




rec{
/int field n-Cassoclid
/cell field *class
/cell field *assoc-Cassoclid
}rec /Cassoclid

: :Cassoclid \ --;<word in input>
  create /Cassoclid allot ;



rec{
/enum field       state-Cstatelist
/enum field       prompt-Cstatelist
/enum field       acknowledgement-Cstatelist
/cell field       *current
/int  field       n-Cstatelist
/cell field       *triggers
/enum field       echotyp
/enum field       echosta
/int  field       echodat
}rec /Cstatelist

: :Cstatelist \ --;<word in input>
  create /Cstatelist allot ;

rec{
/enum       field sample
/enum       field change-Cliddescript
/int        field numassoc
/int        field *trigassoc
/enum       field prompt-Cliddescript
/enum       field acknowledgement-Cliddescript
/cell       field *echo
/cell       field *classdep
/Cstatelist field state-Cliddescript
}rec /Cliddescript

: :Cliddescript \ --;<word in input>
  create /Cliddescript allot ;



rec{
    /int        field      fontset
    /int        field      index
    /int        field      current_font
    /enum       field      precision
    /float      field      exp_factor
    /float      field      space-Ctextatt
    /int        field      color-Ctextatt
    /int        field      height
    /float      field      basex
    /float      field      basey
    /float      field      upx
    /float      field      upy
    /enum       field      path
    /enum       field    halign
    /enum       field    valign
    /float      field    hcalind
    /float      field    vcalind
}rec /Ctextatt


: :Ctextatt \ --;<word in input>
  create /Ctextatt allot ;



rec{
/enum field    change-Ctrigdis
/cell field    *numassoc
/int  field    maxassoc-Ctrigdis
/enum field    prompt-Ctrigdis
/enum field    acknowledgement-Ctrigdis
/cell field    *name
/cell field    *description
}rec /Ctrigdis

: :Ctrigdis \ --;<word in input>
  create /Ctrigdis allot ;



rec{
/enum field       state-Ctrigstate
/cell field      *assoc-Ctrigstate
}rec /Ctrigstate

: :Ctrigstate \ --;<word in input>
  create /Ctrigstate allot ;


rec{
   /int  field        numloc
   /int  field        numval
   /int  field        numstrk
   /int  field        numchoice
   /int  field        numstr
   /int  field        numtrig
   /enum field        event_queue
   /enum field        asynch
   /enum field        coord_map
   /enum field        echo
   /enum field        tracking
   /enum field        prompt-Ccgidesctab
   /enum field        acknowledgement-Ccgidesctab
   /enum field        trigger_manipulation
}rec /Ccgidesctab

: :Ccgidesctab \ --;<word in input>
  create /Ccgidesctab allot ;



rec{
DEVNAMESIZE field screenname[]
DEVNAMESIZE field windowname[]
/int field windowfd
/int field retained
/int field dd
/int field cmapsize
DEVNAMESIZE field cmapname[]
/int field flags
/cell field **ptr
}rec /Cvwsurf

: :Cvwsurf \ --;<word in input>
  create /Cvwsurf allot ;



\ Initialising  a VWSURF to something sensible

: NORMAL_VWSURF \ dev surf --
  swap >R 
          0 R@ screenname[] c!
          0 R@ windowname[] c!
          0 R@ windowfd !
          0 R@ retained !
          R@ dd ! \ store the surf
          0 R@ cmapsize !
          0 R@ cmapname[] c!
          0 R@ flags !
     0 R> **ptr c!
;

